unit grafika;

interface
uses graph,typy,konstant;

procedure power_off; {vykresluje prvky, ktere jsou videt vzdycky}
procedure set_sem(which: word; what: word); {nastavi na semaforu barvicky}
procedure orange(on: boolean);
procedure vykresli_vse(see:boolean);
procedure delky_front(see:boolean); {udaje o delce fronty}
function inicial: boolean; {inicializace grafiky}


implementation
procedure vykresli_vse(see:boolean);
var i: integer;
    this: PJam;
begin
     for i:=1 to 2*smeru do
     begin
         if i<smeru+1 then this:=fs[i]
         else this:=gs[i-smeru];
         while (this<>nil) and (this^.act<>nil) do
         begin
            if see then this^.act^.zobraz
            else this^.act^.smaz;
            this:=this^.next;
         end;
     end;
end;

procedure power_off;

      procedure znacka_hlavni(x,y:integer);
             procedure kosoctverec(x,y,k:integer;color:word);
             begin
                SetColor(color);
                line(x,y+k,x+k,y);
                line(x+k,y,x,y-k);
                line(x,y-k,x-k,y);
                line(x-k,y,x,y+k);
             end;
      var k: integer;
          color: word;
      begin
           color:=6;
           k:=9;
           kosoctverec(x,y,k,color);
           kosoctverec(x,y,k+3,15);
           kosoctverec(x,y,k+2,15);
           kosoctverec(x,y,k+1,15);
           SetFillPattern(full,color);
           FloodFill(x,y,color);
           {kosoctverec}
      end;

      procedure znacka_vedlejsi(x,y:integer; up:boolean);
           procedure trojuhelnik(x,y,k:integer; color:word; up:boolean);
           var i:integer;
           begin
              if up then i:=2
              else
              begin
                 i:=-2;
                 k:=-k;
              end;
              SetColor(color);
              line(x-k-i,y-k,x+k+i,y-k);
              line(x+k+i,y-k,x,y+k*2);
              line(x,y+k*2,x-k-i,y-k);
           end;
      begin
         trojuhelnik(x,y,10,4,up);
         trojuhelnik(x,y,9,4,up);
         trojuhelnik(x,y,8,4,up);
         trojuhelnik(x,y,7,4,up);
         SetFillPattern(full,15);
         FloodFill(x,y,4);
      end;

      procedure semafor_auto(x,y:integer; vertical:boolean);
      begin
           SetFillPattern(full,grey);
           if not vertical then
           begin
             Rectangle(x-9,y-9,x+41,y+9);
             Circle(x+16,y,7);
             Circle(x+32,y,7);
             Circle(x,y,7);
             FloodFill(x+8,y+8,grey);
           end
           else
           begin
            Rectangle(x-9,y-9,x+9,y+41);
            Circle(x,y+16,7);
            Circle(x,y+32,7);
            Circle(x,y,7);
            FloodFill(x+8,y+8,grey);
           end;
      end;

      procedure krizovatka(xa,xb,ya,yb: integer);
      begin
           Line(xa,  0,xa,ya); {levasvisla}
           Line(xb,  0,xb,ya);    {pravasvisla}
           Line(0  ,ya,xa,ya);
           Line(640,ya,xb,ya);
           Line(0  ,yb,xa,yb);
           Line(640,yb,xb,yb);
           Line(xa,480,xa,yb);
           Line(xb,480,xb,yb);
      end;

var i: integer;
    delta: integer;
begin
     SetColor(8);
     krizovatka(xx[1]+30,xx[9]-30,yy[1]+30,yy[9]-30);

     {semafory}
     semafor_auto(xx[1]+13,yy[0]-19,true);
     semafor_auto(xx[9]-13,yy[9]+17,true);
     semafor_auto(xx[0]-13,yy[9]-13,false);
     semafor_auto(xx[9]+10,yy[1]+13,false);

     delta:=13;
     znacka_hlavni(xx[1]+delta,yy[9]-delta);
     znacka_hlavni(xx[9]-delta,yy[1]+delta);
     znacka_vedlejsi(xx[9]-delta,yy[9]-delta,true);
     znacka_vedlejsi(xx[1]+delta,yy[1]+delta,false);

     {napoveda}
     SetColor(4);
     OutTextXY(10,38 ,'Ovladani programu:');
     SetColor(15);
     OutTextXY(10,50 ,'1-4: pridavani do front');
     OutTextXY(10,62 ,'     podle ocislovani');
     OutTextXY(10,74 ,'  p: pozastaveni behu');
     OutTextXY(10,86 ,'  q: ukonceni behu');
     OutTextXY(10,98 ,'  +: prepnuti semaforu');
     OutTextXY(10,110,'  v: vypnuti semaforu');
     OutTextXY(10,122,'     (trvale)');
     OutTextXY(630,235,'1');
     OutTextXY(315,466,'2');
     OutTextXY(12,235,'3');
     OutTextXY(315,12,'4');

end;

procedure delky_front(see: boolean);
var ret: string;
begin
   if see then SetColor(grey)
   else SetColor(0);

   str(l[1],ret);
   ret:='delka fronty: '+ret;
   OutTextXY(500,yy[1]+40,ret);

   str(l[2],ret);
   ret:='delka fronty: '+ret;
   OutTextXY(xx[9]-20,470,ret);

   str(l[3],ret);
   ret:='delka fronty: '+ret;
   OutTextXY(10,yy[9]-43,ret);

   str(l[4],ret);
   ret:='delka fronty: '+ret;
   OutTextXY(100,10,ret);
end;

procedure set_sem(which, what: word);
var x,y,dx,dy,i: integer;
begin
   case which of
      1: begin
           x:=440;
           y:=143;
           dx:=16;
           dy:=0;
         end;
      2: begin
           x:=417;
           y:=367;
           dx:=0;
           dy:=16;
         end;
      3: begin
           x:=199;
           y:=337;
           dx:=-16;
           dy:=0;
         end;
      4: begin
           x:=223;
           y:=113;
           dx:=0;
           dy:=-16;
         end;
   end;     { }
   SetFillPattern(full,0);
   for i:=0 to 2 do FloodFill(x+dx*i,y+dy*i,grey);
   case what of
       1: begin {r}
            SetFillPattern(full,4);
            FloodFill(x,y,grey);
          end;
       2: begin {r+y}
            SetFillPattern(full,4);
            FloodFill(x,y,grey);
            SetFillPattern(full,6);
            FloodFill(x+dx,y+dy,grey);
          end;
       3: begin {g}
            SetFillPattern(full,2);
            FloodFill(x+2*dx,y+2*dy,grey);
          end;
       4: begin {y}
            SetFillPattern(full,6);
            FloodFill(x+dx,y+dy,grey);
          end;
       5: begin
          end;
   end;
end;

procedure orange(on: boolean);
var i: integer;
begin
   if on then for i:=1 to smeru do set_sem(i,4)
   else for i:=1 to smeru do set_sem(i,5);
end;

function inicial: boolean; {inicializace grafiky}
var gr,gi: integer;
begin
    DetectGraph(gr,gi);
    InitGraph(gr,gi,'..\bgi');
    if GraphResult<>grOK then
    begin
       write('Chyba grafiky!');
       inicial:=false;
       exit;
    end;
    ClearDevice;
    inicial:=true;
end;


end.